////////////////////////////////////////////////////////////////////////////////
//    Scorched3D (c) 2000-2003
//
//    This file is part of Scorched3D.
//
//    Scorched3D is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    Scorched3D is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with Scorched3D; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
////////////////////////////////////////////////////////////////////////////////

#if !defined(__INCLUDE_NetServerProtocolh_INCLUDE__)
#define __INCLUDE_NetServerProtocolh_INCLUDE__

#include <coms/NetMessage.h>

class NetServerProtocol
{
public:
	NetServerProtocol();
	virtual ~NetServerProtocol();

	virtual bool sendBuffer(NetBuffer &buffer, TCPsocket socket,
		unsigned int socketId) = 0;
	virtual NetMessage *readBuffer(TCPsocket socket,
		unsigned int socketId) = 0;
};

class NetServerScorchedProtocol : public NetServerProtocol
{
public:
	NetServerScorchedProtocol();
	virtual ~NetServerScorchedProtocol();

	virtual bool sendBuffer(NetBuffer &buffer, TCPsocket socket,
		unsigned int socketId);
	virtual NetMessage *readBuffer(TCPsocket socket,
		unsigned int socketId);
};

class NetServerCompressedProtocol : public NetServerScorchedProtocol
{
public:
	NetServerCompressedProtocol();
	virtual ~NetServerCompressedProtocol();

	virtual bool sendBuffer(NetBuffer &buffer, TCPsocket socket,
		unsigned int socketId);
	virtual NetMessage *readBuffer(TCPsocket socket,
		unsigned int socketId);
};

class NetServerHTTPProtocolSend : public NetServerProtocol
{
public:
	NetServerHTTPProtocolSend();
	virtual ~NetServerHTTPProtocolSend();

	virtual bool sendBuffer(NetBuffer &buffer, TCPsocket socket,
		unsigned int socketId);
	virtual NetMessage *readBuffer(TCPsocket socket,
		unsigned int socketId);
};

class NetServerHTTPProtocolRecv : public NetServerProtocol
{
public:
	NetServerHTTPProtocolRecv();
	virtual ~NetServerHTTPProtocolRecv();

	virtual bool sendBuffer(NetBuffer &buffer, TCPsocket socket,
		unsigned int socketId);
	virtual NetMessage *readBuffer(TCPsocket socket,
		unsigned int socketId);
};

#endif
